/*
 * RiskScape™ Copyright New Zealand Institute for Earth Science Limited
 * (Earth Sciences New Zealand) is distributed for research purposes only
 * under the terms of AGPLv3.
 *
 * RiskScape™ Copyright 2026 New Zealand Institute for Earth Science
 * Limited (Earth Sciences New Zealand). All rights reserved. Source code
 * available under the AGPLv3.
 * 
 * This program is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Affero General Public License as published by the Free
 *  Software Foundation, either version 3 of the License, or (at your option) any
 *  later version.
 * 
 * This program is distributed for RESEARCH PURPOSES ONLY, in the hope that it will
 * be useful for research and education initiatives.
 * 
 * If you are not a researcher, or you are a researcher who wishes to use this
 * program on terms other than AGPLv3 (including those who wish to restrict the
 * distribution of any source code created using this program), please contact:
 * https://riskscape.org.nz
 * 
 * This program is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Affero General Public License for more details.  You should have received a copy
 * of the GNU Affero General Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * By way of summary only, under the AGPLv3:
 *     • Permissions of this strongest copyleft license are conditioned
 *       on making available complete source code of licensed works and
 *       modifications, which include larger works using a licensed work,
 *       under the same license.
 *     • Copyright and license notices must be preserved.
 *     • Contributors provide an express grant of patent rights.
 *     • When a modified version is used to provide a service over a
 *       network, the complete source code of the modified version must be made
 *       available.
 */
package nz.org.riskscape.engine.output;

import static org.hamcrest.Matchers.*;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.junit.Test;

import nz.org.riskscape.engine.Matchers;
import nz.org.riskscape.engine.ProjectTest;
import nz.org.riskscape.engine.bind.ParamProblems;
import nz.org.riskscape.engine.bind.impl.NumberBinder;
import nz.org.riskscape.engine.output.TestFormat.TestFormatOptions;
import nz.org.riskscape.engine.problem.GeneralProblems;
import nz.org.riskscape.engine.resource.CreateHandle;
import nz.org.riskscape.engine.types.Struct;
import nz.org.riskscape.problem.Problem;
import nz.org.riskscape.problem.ResultOrProblems;
import nz.org.riskscape.rl.ExpressionParser;
import nz.org.riskscape.rl.ast.StructDeclaration;

/*
 * Has to be in core, as common is missing ProjectTest
 */
public class BaseFormatTest extends ProjectTest {

  TestFormat subject = new TestFormat(opts -> {});
  String options = "{}";
  TestFormatOptions bound;
  List<Problem> problems;
  // So far we're not using this in any base format tests - if we end up using it, we might want to replace this with
  // a stub implementation, rather than a mock?
  CreateHandle handle = mock(CreateHandle.class);

  @Test
  public void spuriousOptionsAreNoticed() {
    options = "{required: 'foobar', spurious: 'baz'}";

    bind();

    // Urgh, AffectedMetadata is comparing the collection class.
    Problem expectedProblem = ParamProblems.get().ignoredWithHints(
        new HashSet<String>(Set.of("spurious")),
        new HashSet<String>(Set.of("required", "number", "expression"))
    );

    // binding worked
    assertThat(bound, not(nullValue()));
    assertThat(bound.required, is("foobar"));

    // warning returned
    assertThat(problems, contains(
        Matchers.hasAncestorProblem(
            is(expectedProblem)
        )
    ));
  }

  @Test
  public void errorIfOptionsNotRightType() {
    options = "{required: 'foobar', number: 'four'}";

    bind();

    assertThat(problems, contains(
        Matchers.hasAncestorProblem(is(NumberBinder.PROBLEMS.numberFormatException("four", Integer.class)))
    ));
  }

  @Test
  public void optionsCanContainPathExpressions() {
    options = "{required: 'foobar', expression: attr}";

    bind();

    assertThat(bound.expression, Matchers.isPresent(ExpressionParser.parseString("attr")));
  }

  @Test
  public void errorWhenOptionsAreRequiredButNotSpecified() {
    // TestFormatOptions.required is required, so we get an error if the options parameter is omitted
    options = "{}";

    bind();

    assertThat(problems,
        contains(
        is(GeneralProblems.get().required(subject.getWriterParameters().get("required"))))
    );
  }

  ResultOrProblems<TestFormatOptions> bind() {
    ResultOrProblems<TestFormatOptions> resultOr = subject.bindWriterOptions(
        executionContext,
        Struct.EMPTY_STRUCT,
        handle,
        (StructDeclaration) ExpressionParser.parseString(options)
    );

    this.bound = resultOr.orElse(null);
    this.problems = resultOr.getProblems();

    return resultOr;
  }
}
